import * as ec2 from '@aws-cdk/aws-ec2';
/**
 * @stability stable
 */
export declare class AmazonMachineImage {
    /**
     * @stability stable
     */
    static readonly AMAZON_LINUX: ec2.IMachineImage;
    /**
     * @stability stable
     */
    static readonly AMAZON_LINUX_2: ec2.IMachineImage;
    /**
     * CentOS product code from https://wiki.centos.org/Cloud/AWS.
     *
     * @stability stable
     */
    static readonly CENTOS_7: ec2.IMachineImage;
    /**
     * @stability stable
     */
    static readonly CENTOS_8: ec2.IMachineImage;
    /**
     * @stability stable
     */
    static readonly UBUNTU_16_04_AMD64: ec2.IMachineImage;
    /**
     * @stability stable
     */
    static readonly UBUNTU_16_04_ARM64: ec2.IMachineImage;
    /**
     * @stability stable
     */
    static readonly UBUNTU_18_04_AMD64: ec2.IMachineImage;
    /**
     * @stability stable
     */
    static readonly UBUNTU_18_04_ARM64: ec2.IMachineImage;
    /**
     * @stability stable
     */
    static readonly UBUNTU_20_04_AMD64: ec2.IMachineImage;
    /**
     * @stability stable
     */
    static readonly UBUNTU_20_04_ARM64: ec2.IMachineImage;
    /**
     * @stability stable
     */
    static readonly UBUNTU_20_10_AMD64: ec2.IMachineImage;
    /**
     * @stability stable
     */
    static readonly UBUNTU_20_10_ARM64: ec2.IMachineImage;
    /**
     * @stability stable
     */
    static fromSsmParameter(path: string): ec2.IMachineImage;
    /**
     * @stability stable
     */
    constructor();
}
